<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Parsers/Python/__init__.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Parsers/Python/__init__.py</title>
<link href="../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Parsers/Python/__init__.py</b><pre class="sxr"><a id="line1"></a><span class="lineno">  1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno">  2</span><span class="line"><span class="py-comment"># Copyright (C) 2006 Stefan Seefeld</span></span>
<a id="line3"></a><span class="lineno">  3</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line4"></a><span class="lineno">  4</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line5"></a><span class="lineno">  5</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line6"></a><span class="lineno">  6</span><span class="line"><span class="py-comment">#</span></span>
<a id="line7"></a><span class="lineno">  7</span>
<a id="line8"></a><span class="lineno">  8</span><span class="line"><span class="py-keyword">from</span> Synopsis.Processor <span class="py-keyword">import</span> *</span>
<a id="line9"></a><span class="lineno">  9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno"> 10</span><span class="line"><span class="py-keyword">from</span> Synopsis.QualifiedName <span class="py-keyword">import</span> QualifiedPythonName <span class="py-keyword">as</span> QName</span>
<a id="line11"></a><span class="lineno"> 11</span><span class="line"><span class="py-keyword">from</span> Synopsis.SourceFile <span class="py-keyword">import</span> SourceFile</span>
<a id="line12"></a><span class="lineno"> 12</span><span class="line"><span class="py-keyword">from</span> Synopsis.DocString <span class="py-keyword">import</span> DocString</span>
<a id="line13"></a><span class="lineno"> 13</span><span class="line"><span class="py-keyword">from</span> ASGTranslator <span class="py-keyword">import</span> ASGTranslator</span>
<a id="line14"></a><span class="lineno"> 14</span><span class="line"><span class="py-keyword">from</span> SXRGenerator <span class="py-keyword">import</span> SXRGenerator</span>
<a id="line15"></a><span class="lineno"> 15</span><span class="line"><span class="py-keyword">import</span> os</span>
<a id="line16"></a><span class="lineno"> 16</span>
<a id="line17"></a><span class="lineno"> 17</span><span class="line">__all__ = [<span class="py-string">'Parser'</span>]</span>
<a id="line18"></a><span class="lineno"> 18</span>
<a id="line19"></a><span class="lineno"> 19</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/Python.html#expand_package">expand_package</a>(root, verbose = False):</span>
<a id="line20"></a><span class="lineno"> 20</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Find all modules in a given package.&quot;&quot;&quot;</span></span>
<a id="line21"></a><span class="lineno"> 21</span>
<a id="line22"></a><span class="lineno"> 22</span><span class="line">    modules = []</span>
<a id="line23"></a><span class="lineno"> 23</span><span class="line">    <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.isdir(root) <span class="py-keyword">or</span> <span class="py-keyword">not</span> os.path.isfile(os.path.join(root, <span class="py-string">'__init__.py'</span>)):</span>
<a id="line24"></a><span class="lineno"> 24</span><span class="line">        <span class="py-keyword">return</span> modules</span>
<a id="line25"></a><span class="lineno"> 25</span><span class="line">    <span class="py-keyword">if</span> verbose: <span class="py-keyword">print</span> <span class="py-string">'expanding %s'</span>%root</span>
<a id="line26"></a><span class="lineno"> 26</span><span class="line">    files = os.listdir(root)</span>
<a id="line27"></a><span class="lineno"> 27</span><span class="line">    modules += [os.path.join(root, file)</span>
<a id="line28"></a><span class="lineno"> 28</span><span class="line">                <span class="py-keyword">for</span> file <span class="py-keyword">in</span> files <span class="py-keyword">if</span> os.path.splitext(file)[1] == <span class="py-string">'.py'</span>]</span>
<a id="line29"></a><span class="lineno"> 29</span><span class="line">    <span class="py-keyword">for</span> d <span class="py-keyword">in</span> [dir <span class="py-keyword">for</span> dir <span class="py-keyword">in</span> files <span class="py-keyword">if</span> os.path.isdir(os.path.join(root, dir))]:</span>
<a id="line30"></a><span class="lineno"> 30</span><span class="line">        modules.extend(expand_package(os.path.join(root, d), verbose))</span>
<a id="line31"></a><span class="lineno"> 31</span><span class="line">    <span class="py-keyword">return</span> modules</span>
<a id="line32"></a><span class="lineno"> 32</span>
<a id="line33"></a><span class="lineno"> 33</span>
<a id="line34"></a><span class="lineno"> 34</span><span class="line"><span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/Python.html#find_imported">find_imported</a>(target, base_path, origin, verbose = False):</span>
<a id="line35"></a><span class="lineno"> 35</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line36"></a><span class="lineno"> 36</span><span class="line"><span class="py-string">    Lookup imported files, based on current file's location.</span></span>
<a id="line37"></a><span class="lineno"> 37</span><span class="line"><span class="py-string"/></span>
<a id="line38"></a><span class="lineno"> 38</span><span class="line"><span class="py-string">    target: (module, name) pair.</span></span>
<a id="line39"></a><span class="lineno"> 39</span><span class="line"><span class="py-string">    base_path: root directory to which to confine the lookup.</span></span>
<a id="line40"></a><span class="lineno"> 40</span><span class="line"><span class="py-string">    origin: file name of the module issuing the import.&quot;&quot;&quot;</span></span>
<a id="line41"></a><span class="lineno"> 41</span>
<a id="line42"></a><span class="lineno"> 42</span><span class="line">    module, name = target[0].replace(<span class="py-string">'.'</span>, os.sep), target[1]</span>
<a id="line43"></a><span class="lineno"> 43</span><span class="line">    origin = os.path.dirname(origin)</span>
<a id="line44"></a><span class="lineno"> 44</span><span class="line">    <span class="py-keyword">if</span> base_path:</span>
<a id="line45"></a><span class="lineno"> 45</span><span class="line">        locations = [base_path + origin.rsplit(os.sep, i)[0]</span>
<a id="line46"></a><span class="lineno"> 46</span><span class="line">                     <span class="py-keyword">for</span> i <span class="py-keyword">in</span> range(origin.count(os.sep) + 1)] + [base_path]</span>
<a id="line47"></a><span class="lineno"> 47</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line48"></a><span class="lineno"> 48</span><span class="line">        locations = [origin]</span>
<a id="line49"></a><span class="lineno"> 49</span>
<a id="line50"></a><span class="lineno"> 50</span><span class="line">    <span class="py-comment"># '*' is only valid in a module scope</span></span>
<a id="line51"></a><span class="lineno"> 51</span><span class="line">    <span class="py-keyword">if</span> name <span class="py-keyword">and</span> name != <span class="py-string">'*'</span>:</span>
<a id="line52"></a><span class="lineno"> 52</span><span class="line">        <span class="py-comment"># name may be a module or a module's attribute.</span></span>
<a id="line53"></a><span class="lineno"> 53</span><span class="line">        <span class="py-comment"># Only find the module.</span></span>
<a id="line54"></a><span class="lineno"> 54</span><span class="line">        files = [<span class="py-string">'%s/%s.py'</span>%(module, name), <span class="py-string">'%s.py'</span>%module]</span>
<a id="line55"></a><span class="lineno"> 55</span><span class="line">    <span class="py-keyword">else</span>:</span>
<a id="line56"></a><span class="lineno"> 56</span><span class="line">        files = [<span class="py-string">'%s.py'</span>%module]</span>
<a id="line57"></a><span class="lineno"> 57</span><span class="line">    files.append(os.path.join(module, <span class="py-string">'__init__.py'</span>))</span>
<a id="line58"></a><span class="lineno"> 58</span><span class="line">    <span class="py-keyword">for</span> l <span class="py-keyword">in</span> locations:</span>
<a id="line59"></a><span class="lineno"> 59</span><span class="line">        <span class="py-keyword">for</span> f <span class="py-keyword">in</span> files:</span>
<a id="line60"></a><span class="lineno"> 60</span><span class="line">            target = os.path.join(l, f)</span>
<a id="line61"></a><span class="lineno"> 61</span><span class="line">            <span class="py-keyword">if</span> verbose: <span class="py-keyword">print</span> <span class="py-string">'trying %s'</span>%target</span>
<a id="line62"></a><span class="lineno"> 62</span><span class="line">            <span class="py-keyword">if</span> os.path.exists(target):</span>
<a id="line63"></a><span class="lineno"> 63</span><span class="line">                <span class="py-keyword">return</span> target, target[len(base_path):]</span>
<a id="line64"></a><span class="lineno"> 64</span><span class="line">    <span class="py-keyword">return</span> None, None</span>
<a id="line65"></a><span class="lineno"> 65</span>
<a id="line66"></a><span class="lineno"> 66</span>
<a id="line67"></a><span class="lineno"> 67</span>
<a id="line68"></a><span class="lineno"> 68</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/Python/Parser.html">Parser</a>(Processor):</span>
<a id="line69"></a><span class="lineno"> 69</span><span class="line">    <span class="py-string">&quot;&quot;&quot;</span></span>
<a id="line70"></a><span class="lineno"> 70</span><span class="line"><span class="py-string">    Python Parser. See http://www.python.org/dev/peps/pep-0258 for additional</span></span>
<a id="line71"></a><span class="lineno"> 71</span><span class="line"><span class="py-string">    info.&quot;&quot;&quot;</span></span>
<a id="line72"></a><span class="lineno"> 72</span>
<a id="line73"></a><span class="lineno"> 73</span><span class="line">    primary_file_only = Parameter(True, <span class="py-string">'should only primary file be processed'</span>)</span>
<a id="line74"></a><span class="lineno"> 74</span><span class="line">    base_path = Parameter(None, <span class="py-string">'Path prefix to strip off of input file names.'</span>)</span>
<a id="line75"></a><span class="lineno"> 75</span><span class="line">    sxr_prefix = Parameter(None, <span class="py-string">'Path prefix (directory) to contain sxr info.'</span>)</span>
<a id="line76"></a><span class="lineno"> 76</span><span class="line">    default_docformat = Parameter(<span class="py-string">''</span>, <span class="py-string">'default documentation format'</span>)</span>
<a id="line77"></a><span class="lineno"> 77</span>
<a id="line78"></a><span class="lineno"> 78</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/Python/Parser.html#process">process</a>(self, ir, **kwds):</span>
<a id="line79"></a><span class="lineno"> 79</span>
<a id="line80"></a><span class="lineno"> 80</span><span class="line">        self.set_parameters(kwds)</span>
<a id="line81"></a><span class="lineno"> 81</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.input: <span class="py-keyword">raise</span> MissingArgument(<span class="py-string">'input'</span>)</span>
<a id="line82"></a><span class="lineno"> 82</span><span class="line">        self.ir = ir</span>
<a id="line83"></a><span class="lineno"> 83</span><span class="line">        self.scopes = []</span>
<a id="line84"></a><span class="lineno"> 84</span>
<a id="line85"></a><span class="lineno"> 85</span><span class="line">        <span class="py-comment"># Create return type for Python functions:</span></span>
<a id="line86"></a><span class="lineno"> 86</span><span class="line">        self.return_type = ASG.BuiltinTypeId(<span class="py-string">'Python'</span>,(<span class="py-string">''</span>,))</span>
<a id="line87"></a><span class="lineno"> 87</span>
<a id="line88"></a><span class="lineno"> 88</span><span class="line">        <span class="py-comment"># Validate base_path.</span></span>
<a id="line89"></a><span class="lineno"> 89</span><span class="line">        <span class="py-keyword">if</span> self.base_path:</span>
<a id="line90"></a><span class="lineno"> 90</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.isdir(self.base_path):</span>
<a id="line91"></a><span class="lineno"> 91</span><span class="line">                <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'base_path: &quot;%s&quot; not a directory.'</span></span>
<a id="line92"></a><span class="lineno"> 92</span><span class="line">                                      %self.base_path)</span>
<a id="line93"></a><span class="lineno"> 93</span><span class="line">            <span class="py-keyword">if</span> self.base_path[-1] != os.sep:</span>
<a id="line94"></a><span class="lineno"> 94</span><span class="line">                self.base_path += os.sep</span>
<a id="line95"></a><span class="lineno"> 95</span>
<a id="line96"></a><span class="lineno"> 96</span><span class="line">        <span class="py-comment"># all_files is a list of (filename, base_path) pairs.</span></span>
<a id="line97"></a><span class="lineno"> 97</span><span class="line">        <span class="py-comment"># we have to record the base_path per file, since it defaults to the</span></span>
<a id="line98"></a><span class="lineno"> 98</span><span class="line">        <span class="py-comment"># filename itself, for files coming directly from user input.</span></span>
<a id="line99"></a><span class="lineno"> 99</span><span class="line">        <span class="py-comment"># For files that are the result of expanded packages it defaults to the</span></span>
<a id="line100"></a><span class="lineno">100</span><span class="line">        <span class="py-comment"># package directory itself.</span></span>
<a id="line101"></a><span class="lineno">101</span><span class="line">        self.all_files = []</span>
<a id="line102"></a><span class="lineno">102</span><span class="line">        <span class="py-keyword">for</span> i <span class="py-keyword">in</span> self.input:</span>
<a id="line103"></a><span class="lineno">103</span><span class="line">            base_path = self.base_path <span class="py-keyword">or</span> os.path.dirname(i)</span>
<a id="line104"></a><span class="lineno">104</span><span class="line">            <span class="py-keyword">if</span> base_path <span class="py-keyword">and</span> base_path[-1] != os.sep:</span>
<a id="line105"></a><span class="lineno">105</span><span class="line">                base_path += os.sep</span>
<a id="line106"></a><span class="lineno">106</span><span class="line">            <span class="py-comment"># expand packages into modules</span></span>
<a id="line107"></a><span class="lineno">107</span><span class="line">            <span class="py-keyword">if</span> os.path.isdir(i):</span>
<a id="line108"></a><span class="lineno">108</span><span class="line">                <span class="py-keyword">if</span> os.path.exists(os.path.join(i, <span class="py-string">'__init__.py'</span>)):</span>
<a id="line109"></a><span class="lineno">109</span><span class="line">                    self.all_files.extend([(p,base_path)</span>
<a id="line110"></a><span class="lineno">110</span><span class="line">                                           <span class="py-keyword">for</span> p <span class="py-keyword">in</span> expand_package(i, self.verbose)])</span>
<a id="line111"></a><span class="lineno">111</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line112"></a><span class="lineno">112</span><span class="line">                    <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'&quot;%s&quot; is not a Python package'</span>%i)</span>
<a id="line113"></a><span class="lineno">113</span><span class="line">            <span class="py-keyword">else</span>:</span>
<a id="line114"></a><span class="lineno">114</span><span class="line">                self.all_files.append((i,base_path))</span>
<a id="line115"></a><span class="lineno">115</span><span class="line">        <span class="py-comment"># process modules</span></span>
<a id="line116"></a><span class="lineno">116</span><span class="line">        <span class="py-keyword">while</span> len(self.all_files):</span>
<a id="line117"></a><span class="lineno">117</span><span class="line">            file, base_path = self.all_files.pop()</span>
<a id="line118"></a><span class="lineno">118</span><span class="line">            self.process_file(file, base_path)</span>
<a id="line119"></a><span class="lineno">119</span>
<a id="line120"></a><span class="lineno">120</span><span class="line">        <span class="py-keyword">return</span> self.output_and_return_ir()</span>
<a id="line121"></a><span class="lineno">121</span>
<a id="line122"></a><span class="lineno">122</span>
<a id="line123"></a><span class="lineno">123</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../Scopes/Synopsis/Parsers/Python/Python/Parser.html#process_file">process_file</a>(self, filename, base_path):</span>
<a id="line124"></a><span class="lineno">124</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Parse an individual python file.&quot;&quot;&quot;</span></span>
<a id="line125"></a><span class="lineno">125</span>
<a id="line126"></a><span class="lineno">126</span><span class="line">        long_filename = filename</span>
<a id="line127"></a><span class="lineno">127</span><span class="line">        <span class="py-keyword">if</span> filename[:len(base_path)] != base_path:</span>
<a id="line128"></a><span class="lineno">128</span><span class="line">            <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'invalid input filename:\n'</span></span>
<a id="line129"></a><span class="lineno">129</span><span class="line">                                  <span class="py-string">'&quot;%s&quot; does not match base_path &quot;%s&quot;'</span></span>
<a id="line130"></a><span class="lineno">130</span><span class="line">                                  %(filename, base_path))</span>
<a id="line131"></a><span class="lineno">131</span><span class="line">        <span class="py-keyword">if</span> self.verbose: <span class="py-keyword">print</span> <span class="py-string">'parsing %s'</span>%filename</span>
<a id="line132"></a><span class="lineno">132</span><span class="line">        short_filename = filename[len(base_path):]</span>
<a id="line133"></a><span class="lineno">133</span><span class="line">        sourcefile = SourceFile(short_filename, long_filename, <span class="py-string">'Python'</span>, True)</span>
<a id="line134"></a><span class="lineno">134</span><span class="line">        self.ir.files[short_filename] = sourcefile</span>
<a id="line135"></a><span class="lineno">135</span>
<a id="line136"></a><span class="lineno">136</span><span class="line">        package = None</span>
<a id="line137"></a><span class="lineno">137</span><span class="line">        package_name = []</span>
<a id="line138"></a><span class="lineno">138</span><span class="line">        package_path = base_path</span>
<a id="line139"></a><span class="lineno">139</span><span class="line">        <span class="py-comment"># Only attempt to set up enclosing packages if a base_path was given.</span></span>
<a id="line140"></a><span class="lineno">140</span><span class="line">        <span class="py-keyword">if</span> package_path != filename:</span>
<a id="line141"></a><span class="lineno">141</span><span class="line">            components = short_filename.split(os.sep)</span>
<a id="line142"></a><span class="lineno">142</span><span class="line">            <span class="py-keyword">if</span> components[0] == <span class="py-string">''</span>:</span>
<a id="line143"></a><span class="lineno">143</span><span class="line">                package_path += os.sep</span>
<a id="line144"></a><span class="lineno">144</span><span class="line">                components = components[1:]</span>
<a id="line145"></a><span class="lineno">145</span><span class="line">            <span class="py-keyword">for</span> c <span class="py-keyword">in</span> components[:-1]:</span>
<a id="line146"></a><span class="lineno">146</span><span class="line">                package_name.append(c)</span>
<a id="line147"></a><span class="lineno">147</span><span class="line">                package_path = os.path.join(package_path, c)</span>
<a id="line148"></a><span class="lineno">148</span><span class="line">                qname = QName(package_name)</span>
<a id="line149"></a><span class="lineno">149</span><span class="line">                <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.isfile(os.path.join(package_path, <span class="py-string">'__init__.py'</span>)):</span>
<a id="line150"></a><span class="lineno">150</span><span class="line">                    <span class="py-keyword">raise</span> InvalidArgument(<span class="py-string">'&quot;%s&quot; is not a package'</span>%qname)</span>
<a id="line151"></a><span class="lineno">151</span><span class="line">                <span class="py-comment"># Try to locate the package</span></span>
<a id="line152"></a><span class="lineno">152</span><span class="line">                type_id = self.ir.asg.types.get(qname)</span>
<a id="line153"></a><span class="lineno">153</span><span class="line">                <span class="py-keyword">if</span> (type_id):</span>
<a id="line154"></a><span class="lineno">154</span><span class="line">                    module = type_id.declaration</span>
<a id="line155"></a><span class="lineno">155</span><span class="line">                <span class="py-keyword">else</span>:</span>
<a id="line156"></a><span class="lineno">156</span><span class="line">                    module = ASG.Module(sourcefile, -1, <span class="py-string">'package'</span>, qname)</span>
<a id="line157"></a><span class="lineno">157</span><span class="line">                    self.ir.asg.types[qname] = ASG.DeclaredTypeId(<span class="py-string">'Python'</span>, qname, module)</span>
<a id="line158"></a><span class="lineno">158</span><span class="line">                    <span class="py-keyword">if</span> package:</span>
<a id="line159"></a><span class="lineno">159</span><span class="line">                        package.declarations.append(module)</span>
<a id="line160"></a><span class="lineno">160</span><span class="line">                    <span class="py-keyword">else</span>:</span>
<a id="line161"></a><span class="lineno">161</span><span class="line">                        self.ir.asg.declarations.append(module)</span>
<a id="line162"></a><span class="lineno">162</span>
<a id="line163"></a><span class="lineno">163</span><span class="line">                package = module</span>
<a id="line164"></a><span class="lineno">164</span>
<a id="line165"></a><span class="lineno">165</span><span class="line">        translator = ASGTranslator(package, self.ir.asg.types, self.default_docformat)</span>
<a id="line166"></a><span class="lineno">166</span><span class="line">        translator.process_file(sourcefile)</span>
<a id="line167"></a><span class="lineno">167</span><span class="line">        <span class="py-comment"># At this point, sourcefile contains a single declaration: the module.</span></span>
<a id="line168"></a><span class="lineno">168</span><span class="line">        <span class="py-keyword">if</span> package:</span>
<a id="line169"></a><span class="lineno">169</span><span class="line">            package.declarations.extend(sourcefile.declarations)</span>
<a id="line170"></a><span class="lineno">170</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line171"></a><span class="lineno">171</span><span class="line">            self.ir.asg.declarations.extend(sourcefile.declarations)</span>
<a id="line172"></a><span class="lineno">172</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> self.primary_file_only:</span>
<a id="line173"></a><span class="lineno">173</span><span class="line">            <span class="py-keyword">for</span> i <span class="py-keyword">in</span> translator.imports:</span>
<a id="line174"></a><span class="lineno">174</span><span class="line">                target = find_imported(i, self.base_path, sourcefile.name, self.verbose)</span>
<a id="line175"></a><span class="lineno">175</span><span class="line">                <span class="py-keyword">if</span> target[0] <span class="py-keyword">and</span> target[1] <span class="py-keyword">not</span> <span class="py-keyword">in</span> self.ir.files:</span>
<a id="line176"></a><span class="lineno">176</span><span class="line">                    <span class="py-comment"># Only process if we have not visited it yet.</span></span>
<a id="line177"></a><span class="lineno">177</span><span class="line">                    self.all_files.append((target[0], base_path))</span>
<a id="line178"></a><span class="lineno">178</span>
<a id="line179"></a><span class="lineno">179</span><span class="line">        <span class="py-keyword">if</span> self.sxr_prefix:</span>
<a id="line180"></a><span class="lineno">180</span><span class="line">            sxr = os.path.join(self.sxr_prefix, short_filename + <span class="py-string">'.sxr'</span>)</span>
<a id="line181"></a><span class="lineno">181</span><span class="line">            dirname = os.path.dirname(sxr)</span>
<a id="line182"></a><span class="lineno">182</span><span class="line">            <span class="py-keyword">if</span> <span class="py-keyword">not</span> os.path.exists(dirname):</span>
<a id="line183"></a><span class="lineno">183</span><span class="line">                os.makedirs(dirname, 0755)</span>
<a id="line184"></a><span class="lineno">184</span>
<a id="line185"></a><span class="lineno">185</span><span class="line">            sxr_generator = SXRGenerator()</span>
<a id="line186"></a><span class="lineno">186</span><span class="line">            module = sourcefile.declarations[0]</span>
<a id="line187"></a><span class="lineno">187</span><span class="line">            sxr_generator.process_file(module.name, sourcefile, sxr)</span>
<a id="line188"></a><span class="lineno">188</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
